# Message Formats (DRAFT)
Consists of all messages transferred into and out of the Communications Backbone. Message type schemas will be developed once reviewing each platform's data and statuses defined by each partner.

## Message Types

| Type                       | Summary of File                                                                                  | Human-Readable  |
|--------------------------- | ------------------------------------------------------------------------------------------------ | ----------------|
| `autonomy_configuration`   |  Autonomy Engine's Configuration file (sent by each C2 if there are any changes)                 | Yes             |
| `autonomy_mission_plan`    |  Mission plan generated by Autonomy Engine per platform                                          | Yes             |
| `mission_plan`             |  Encoded/serialized platform-specific mission plan  **(shared filepath)**                        | No              |
| `platform_status`          |  Encoded/serialized platform-specific platform status **(shared filepath)**                      | No              |
| `platform_status`          |  Decoded/de-serialized generic platform status                                                   | Yes             |
| `observation`              |  Encoded/serialized observation data from platform for Autonomy Engine **(shared filepath)**     | No              |
| `observation`              |  Decoded/de-serialized observation data from platform for Autonomy Engine                        | Yes             |


## Breakdown of Message Sources & Types
### 1/ Autonomy Engine
#### Transmit
* mission plan _(sent per platform)_
* TBD: 
    * Will emergency commands be sent via the autonomy engine (from the GUI) or directly to the C2s?

#### Receive
* configuration file
* emergency stop all
* decoded ecosub status message
* decoded reav status message
* decoded autosub-hover status message
* decoded ecosub observation data _(from squad 1 platforms)_

----------------------------------

### 2/ Ecosub C2
#### Transmit
* compiled ecosub mission plan
* decoded ecosub status message
* configuration file
* decoded ecosub observation data


#### Receive
* mission plan
* encoded ecosub status message
* encoded ecosub observation data

----------------------------------

### 3/ Autosub C2 
#### Transmit
* compiled autosub-hover mission plan
* decoded autosub-hover status message
* configuration file


#### Receive
* mission plan
* encoded autosub-hover status message


----------------------------------

### 4/ Reav C2 
#### Transmit
* decoded reav-60 status message?


#### Receive
* mission plan
* encoded reav-60 status message?

----------------------------------

### 5/ Hermes Box/Hydrosurv Smart Router? 
#### Transmit
* encoded ecosub status message
* encoded (or is this already decoded?) reav status message
* encoded autosub status message
* encoded ecosub observation data
* TBD: 
    * are there acknowledgment messages from platforms?
    * how are we receiving beacon messages per platform?

#### Receive
* compiled ecosub mission plan
* compiled reav mission plan
* compiled autosub mission plan
* compiled ecosub emergency command
* compiled reav emergency command
* compiled autosub emergency command
